Subject: Re: [PATCH v5 00/44] Make git-am a builtin

From: Junio C Hamano <[email-masked]>
Date: Tue, 07 Jul 2015 11:52:23 -0700

Paul Tan <[email-masked]> writes:

> This patch series depends on pt/pull-builtin.
>
> This is a re-roll of [v4]. Thanks Torsten, Stefan, Junio for the reviews last
> round. Interdiff below.
>
> Previous versions:
>
> [WIP v1] http://thread.gmane.org/gmane.comp.version-control.git/270048
> [WIP v2] http://thread.gmane.org/gmane.comp.version-control.git/271381
> [WIP v3] http://thread.gmane.org/gmane.comp.version-control.git/271967
> [v4] http://thread.gmane.org/gmane.comp.version-control.git/272876
>
> git-am is a commonly used command for applying a series of patches from a
> mailbox to the current branch. Currently, it is implemented by the shell script
> git-am.sh. However, compared to C, shell scripts have certain deficiencies:
> they need to spawn a lot of processes, introduce a lot of dependencies and
> cannot take advantage of git's internal caches.
>
> This patch series rewrites git-am.sh into optimized C builtin/am.c, and is
> part of my GSoC project to rewrite git-pull and git-am into C builtins[1].
>
> [1] https://gist.github.com/pyokagan/1b7b0d1f4dab6ba3cef1

Is it really a rewrite into "optimized C", or just "C"?  I suspect
it is the latter.

This seems to apply cleanly to 'master' but fails to compile, as it
depends on some new stuff that are not even in 'next' yet, e.g.
argv_array_pushv() that is from pt/pull-builtin, and it does not
apply cleanly on top of that branch, either.

I'll see what's the cleanest way to queue this would be.  Perhaps
merge pt/builtin-pull on a copy of 'master' and then apply these, or
something like that.

Thanks.